/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.system.expand.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.system.entity.Dept;
import org.springblade.system.feign.ISysClient;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.system.expand.entity.OrgPosition;
import org.springblade.system.expand.vo.OrgPositionVO;
import org.springblade.system.expand.wrapper.OrgPositionWrapper;
import org.springblade.system.expand.service.IOrgPositionService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-03-29
 */
@RestController
@AllArgsConstructor
@RequestMapping("/orgposition")
@Api(value = "机构路径", tags = "机构路径")
public class OrgPositionController extends BladeController {

	private final IOrgPositionService orgPositionService;
	private final ISysClient sysClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入orgPosition")
	public R<OrgPositionVO> detail(OrgPosition orgPosition) {
		OrgPosition detail = orgPositionService.getOne(Condition.getQueryWrapper(orgPosition));
		return R.data(OrgPositionWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入orgPosition")
	public R<IPage<OrgPositionVO>> list(OrgPosition orgPosition, Query query) {
		IPage<OrgPosition> pages = orgPositionService.page(Condition.getPage(query), Condition.getQueryWrapper(orgPosition));
		return R.data(OrgPositionWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入orgPosition")
	public R<IPage<OrgPositionVO>> page(OrgPositionVO orgPosition, Query query) {
		IPage<OrgPositionVO> pages = orgPositionService.selectOrgPositionPage(Condition.getPage(query), orgPosition);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入orgPosition")
	public R save(@Valid @RequestBody OrgPosition orgPosition) {
		return R.status(orgPositionService.save(orgPosition));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入orgPosition")
	public R update(@Valid @RequestBody OrgPosition orgPosition) {
		return R.status(orgPositionService.updateById(orgPosition));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入orgPosition")
	public R submit(@Valid @RequestBody OrgPosition orgPosition) {
		Assert.notNull(orgPosition.getOrgId(),"机构id不能为空");
		Dept dept = sysClient.getDept(orgPosition.getOrgId()).getData();
		Assert.notNull(dept,"找不到对应的机构");
		orgPosition.setTenantId(dept.getTenantId());
		OrgPosition oldEntity = orgPositionService.getBaseMapper().selectOne(new QueryWrapper<>(new OrgPosition()).lambda().eq(OrgPosition::getOrgId, orgPosition.getOrgId()));
		if(oldEntity != null){//修改
			orgPosition.setId(oldEntity.getId());
		}
		StringBuffer stringBuffer = new StringBuffer();
		String initOrgPosition = "/"+orgPosition.getProvinceCode()+"/"+orgPosition.getCityCode()+"/"+orgPosition.getAreaCode()
			+"/"+orgPosition.getStreetCode()+"/"+orgPosition.getAgencyId()+"/"+orgPosition.getResidentialId();
		String orgposition1 = initOrgPosition.split("/null")[0];
		orgPosition.setOrgPosition(orgposition1);
		while (orgPosition.getOrgPosition().endsWith("/")){
			int length = orgPosition.getOrgPosition().length();
			orgPosition.setOrgPosition(orgPosition.getOrgPosition().substring(0,length-1));
		}

		return R.status(orgPositionService.saveOrUpdate(orgPosition));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(orgPositionService.deleteLogic(Func.toLongList(ids)));
	}


}
